{-# LANGUAGE ViewPatterns #-}

module Main (main) where
import Data.Char (isDigit)
import Data.List (isPrefixOf)
import Data.Maybe (fromJust)
import Control.Applicative ((<|>))

findNumeral :: String -> Maybe Integer
findNumeral (isPrefixOf "one" -> True) = Just 1
findNumeral (isPrefixOf "two" -> True) = Just 2
findNumeral (isPrefixOf "three" -> True) = Just 3
findNumeral (isPrefixOf "four" -> True) = Just 4
findNumeral (isPrefixOf "five" -> True) = Just 5
findNumeral (isPrefixOf "six" -> True) = Just 6
findNumeral (isPrefixOf "seven" -> True) = Just 7
findNumeral (isPrefixOf "eight" -> True) = Just 8
findNumeral (isPrefixOf "nine" -> True) = Just 9
findNumeral (isPrefixOf "zero" -> True) = Just 0
findNumeral _ = Nothing

findDigit :: String -> Maybe Integer
findDigit (findNumeral -> Just d) = Just d
findDigit (digit@(isDigit -> True) : _) = Just (read [digit] :: Integer)
findDigit  _ = Nothing

findDigitFirst :: String -> Maybe Integer
findDigitFirst (findDigit -> Just d) = Just d
findDigitFirst (_ : t) = findDigitFirst t 
findDigitFirst _ = Nothing

findDigitLast :: String -> Maybe Integer
findDigitLast (x : xs) = findDigitLast xs <|> findDigit (x : xs)
findDigitLast [] = Nothing

main :: IO ()
main = do
    lns <- lines <$> getContents
    let values = (\x -> fromJust (findDigitFirst x) * 10 + fromJust (findDigitLast x)) <$> lns
    print $ sum values
