{-# LANGUAGE ViewPatterns #-}

module Main (main) where

import Data.Char (isDigit)
import Data.List (elemIndices)

numberChunks :: [Char] -> [(Integer, Int, Int)]
numberChunks [] = []
numberChunks ((isDigit -> False) : xs) = (\(s, i, l) -> (s, i + 1, l)) <$> numberChunks xs
numberChunks items = (\(a, b) -> (read a :: Integer, 0, length a) : ((\(s, i, l) -> (s, i + length a, l)) <$> numberChunks b)) $ span isDigit items

isTouching :: (Int, Int) -> (Int, (Integer, Int, Int)) -> Bool
isTouching (y, x) (cy, (_, cx, clen)) = abs (y - cy) <= 1 && any ((<= 1) . abs . (x -)) [cx .. cx + clen - 1]

fstOf3 :: (a, b, c) -> a
fstOf3 (a, _, _) = a

main :: IO ()
main = do
  lns <- lines <$> getContents
  let chunks = concat [(,) i <$> it | (i, it) <- zip [0 ..] (numberChunks <$> lns)]
  let asterisks = concat [(,) i <$> it | (i, it) <- zip [0 ..] $ elemIndices '*' <$> lns]
  let gearRatios = ((fstOf3 . snd <$>) <$>) . filter ((== 2) . length) $ (`filter` chunks) . isTouching <$> asterisks
  print $ sum $ product <$> gearRatios