{-# LANGUAGE TypeApplications #-}
{-# LANGUAGE ViewPatterns #-}

module Main (main) where
import qualified Data.Set as S
import qualified Data.Text as T
import qualified Data.Text.Read as T
import GHC.Num (integerFromInt)
import Data.Either.Combinators (fromRight')

parseNums :: [T.Text] -> S.Set Integer
parseNums nums = S.fromList $ fst . fromRight' . T.decimal @Integer <$> nums

parseCard :: [T.Text] -> [S.Set Integer]
parseCard [T.words -> [T.unpack -> "Card", T.decimal @Integer -> Right _], numbers] =
    parseNums
    . T.words
    <$> T.splitOn (T.pack "|") numbers
parseCard _ = error "parseCard error"

getWinnings :: Integer -> [Integer] -> Integer
getWinnings 0 _ = 0
getWinnings n (h : t) = (h + getWinnings h t) + getWinnings (n - 1) t
getWinnings _ [] = error "Out of bounds"

getWinningsTotal :: [Integer] -> Integer
getWinningsTotal arr = (\len -> len + getWinnings len arr) $ integerFromInt (length arr)

main :: IO ()
main = do
    cards <- (parseCard . T.splitOn (T.pack ": ") . T.pack <$>) . lines <$> getContents
    print $ getWinningsTotal (integerFromInt . length . S.toList . foldl1 S.intersection <$> cards)