{-# LANGUAGE OverloadedStrings #-}
{-# LANGUAGE ViewPatterns #-}
{-# LANGUAGE TypeApplications #-}
{-# LANGUAGE ScopedTypeVariables #-}

module Main (main) where

import qualified Data.Text as T
import Data.List ( transpose )
import Data.Bifunctor (Bifunctor(bimap))

parseRace :: [T.Text] -> (Integer, Integer)
parseRace [read @Integer . T.unpack -> time, read @Integer . T.unpack -> dist] = (time, dist)
parseRace _ = error "Parse"

main :: IO ()
main = do
    lns <- lines <$> getContents
    print
        $ (\(time, dist) -> (\x -> ceiling (time / 2 + x) - floor (time / 2 - x) - 1) 
            . sqrt 
            . subtract dist 
            . (**2) 
            . (/2) $ time) 
        . bimap (fromIntegral @_ @Double) (fromIntegral @_ @Double) 
        $ parseRace 
        $ T.concat <$> (transpose . drop 1 . transpose $ T.words . T.pack <$> lns)