{-# LANGUAGE ImportQualifiedPost #-}

module Main (main) where

import Data.Map qualified as M

parseMove :: Char -> (a, a) -> a
parseMove 'L' = fst
parseMove 'R' = snd

parseNode :: String -> (String, (String, String))
parseNode = (,) . take 3 <*> ((,) . take 3 . drop 7 <*> take 3 . drop 12)

main :: IO ()
main = do
  lns <- lines <$> getContents
  let moves = cycle (parseMove <$> concat (take 1 lns))
  let nodes = M.fromList $ parseNode <$> drop 2 lns

  let doMove i "ZZZ" _ = i
      doMove i node (x : xs) = doMove (i + 1) (x $ nodes M.! node) xs

  print $ doMove 0 "AAA" moves