{-# LANGUAGE ImportQualifiedPost #-}

module Main (main) where

import Data.Map qualified as M

parseMove :: Char -> (a, a) -> a
parseMove 'L' = fst
parseMove 'R' = snd

parseNode :: String -> (String, (String, String))
parseNode = (,) . take 3 <*> ((,) . take 3 . drop 7 <*> take 3 . drop 12)

main :: IO ()
main = do
  moves <- cycle . (parseMove <$>) <$> getLine
  nodes <- M.fromList . ((parseNode <$>) . drop 1 . lines) <$> getContents

  let doMove i [_, _, 'Z'] _ = i
      doMove i node (x : xs) = doMove (i + 1) (x $ nodes M.! node) xs

  print $ foldl1 lcm $ flip (doMove 0) moves <$> filter ((== 'A') . last) (M.keys nodes)