module Main (main) where
import Control.Conditional (ifM)
import Data.List (singleton, transpose)

manhattan :: Num a => (a, a) -> (a, a) -> a
manhattan (ax, ay) (bx, by) = abs (ax - bx) + abs (ay - by)

inflate :: [String] -> [String]
inflate = concatMap (ifM (all (=='.')) (replicate 2) singleton)

main :: IO ()
main = do
    lns <- lines <$> getContents

    print $ sum
        . fmap sum
        . (zipWith (fmap . manhattan) <*> takeWhile (not . null) . iterate (drop 1))
        . concatMap (zip <$> repeat . fst <*> snd . fmap (fmap snd . filter ((=='#') . fst)))
        . zip [0..]
        . fmap (`zip` [0..])
        . inflate
        . transpose
        . inflate
        $ lns