module Main (main) where
import Control.Conditional (ifM)
import Data.List (transpose)

manhattan :: Num a => (a, a) -> (a, a) -> a
manhattan (ax, ay) (bx, by) = abs (ax - bx) + abs (ay - by)

inflate :: [String] -> [String]
inflate = fmap (ifM (all ((||) <$> (=='.') <*> (=='V'))) (fmap (const 'V')) id)

inflationFactor :: Char -> Integer
inflationFactor 'V' = 1000000
inflationFactor _ = 1

main :: IO ()
main = do
    lns <- lines <$> getContents

    print $ sum
        . fmap sum
        . (zipWith (fmap . manhattan) <*> takeWhile (not . null) . iterate (drop 1))
        . concatMap (zip <$> repeat . fst <*> snd . fmap (fmap snd . filter ((=='#') . fst)))
        . (zip <$> (scanl1 (+) . fmap (inflationFactor . fst . head)) <*> id)
        . fmap (zip <$> id <*> scanl1 (+) . fmap inflationFactor)
        . inflate
        . transpose
        . inflate
        $ lns